var gulp = require('gulp');
var sass = require('gulp-sass');
var sourcemaps = require('gulp-sourcemaps');
var autoprefixer = require('gulp-autoprefixer');
var imagemin = require('gulp-imagemin');
var webp = require('gulp-webp');
var webpcss = require("gulp-webpcss");

var SASS = 'sass';
var CSS = 'css';
var IMG = 'img';

var autoprefixerOptions = {
  browsers: ['> 1%']
};

var webpcssOptions = {
  webpClass: '',
  noWebpClass: '.no-webp'
};

// tasks

gulp.task('sass', done => {
  gulp.src(SASS + '/**/*.scss')
    .pipe(sourcemaps.init())
    .pipe(sass.sync({}).on('error', sass.logError))
    .pipe(autoprefixer(autoprefixerOptions))
    .pipe(webpcss(webpcssOptions))
    .pipe(sourcemaps.write('../css'))
    .pipe(gulp.dest(CSS));
  done();
});

gulp.task('imagemin', done => {
  gulp.src(IMG + '/src/*')
    .pipe(imagemin())
    .pipe(gulp.dest(IMG));
  done();
});

gulp.task('webp', done => {
  gulp.src(IMG + '/src/*')
    .pipe(webp({quality: 90}))
    .pipe(gulp.dest(IMG));
  done();
});

gulp.task('build', gulp.series('sass', 'imagemin', 'webp'));

gulp.task('watch', function () {
  return gulp.watch(SASS + '/**/*.scss', gulp.series(gulp.series('sass', 'imagemin', 'webp')));
});

gulp.task('default', gulp.series('build', 'watch'));
